GNU bug report logs - #49515
[core-updates] mescc-tools tests fail

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: guix; Reported by: Ludovic Courtès <ludo@HIDDEN>; merged with #48595; Done: Ludovic Courtès <ludo@HIDDEN>; Maintainer for guix is bug-guix@HIDDEN.
Merged 48595 49515. Request was from Ludovic Courtès <ludo@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 49515 <at> debbugs.gnu.org:


Received: (at 49515) by debbugs.gnu.org; 26 Jul 2021 13:44:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jul 26 09:44:06 2021
Received: from localhost ([127.0.0.1]:50254 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1m80tp-0003ZP-KA
	for submit <at> debbugs.gnu.org; Mon, 26 Jul 2021 09:44:05 -0400
Received: from eggs.gnu.org ([209.51.188.92]:35080)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <janneke@HIDDEN>) id 1m80tl-0003Yc-1B
 for 49515 <at> debbugs.gnu.org; Mon, 26 Jul 2021 09:44:04 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:42146)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <janneke@HIDDEN>)
 id 1m80tf-0005IG-P4; Mon, 26 Jul 2021 09:43:55 -0400
Received: from [2001:980:1b4f:1:42d2:832d:bb59:862] (port=57102
 helo=dundal.janneke.lilypond.org)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <janneke@HIDDEN>)
 id 1m80tf-00009C-ER; Mon, 26 Jul 2021 09:43:55 -0400
From: Jan Nieuwenhuizen <janneke@HIDDEN>
To: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>
Subject: Re: bug#49515: [core-updates] mescc-tools tests fail
Organization: AvatarAcademy.nl
References: <87k0lxafl6.fsf@HIDDEN> <87o8az49ly.fsf@HIDDEN>
 <87im16j4bo.fsf@HIDDEN> <87fsw18fre.fsf@HIDDEN>
X-Url: http://AvatarAcademy.nl
Date: Mon, 26 Jul 2021 15:43:53 +0200
In-Reply-To: <87fsw18fre.fsf@HIDDEN> ("Ludovic =?utf-8?Q?Court=C3=A8s=22'?=
 =?utf-8?Q?s?= message of "Mon, 26 Jul 2021 13:40:37 +0200")
Message-ID: <87pmv5kx5y.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 49515
Cc: 49515 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Ludovic Court=C3=A8s writes:

Hi Ludo!

> Jan Nieuwenhuizen <janneke@HIDDEN> skribis:
>
>>> Should we upgrade instead?  If we do, what=E2=80=99s the potential for =
breakage?
>>> Should =E2=80=98mes-rb5=E2=80=99 be kept on an older version?
>>
>> We could try that, I really can't tell if upgrading to 1.1.0 creates
>> a different mes binary.
>
> I took this route and everything went well, and we can now build
> =E2=80=98bootstrap-tarballs=E2=80=99 on x86_64-linux.  I ended up doing a=
dditional
> changes:
>
>   e2690a8eb2 gnu: mes-rb5: Remove.
>   da32015db0 gnu: mes-minimal-stripped: Explicitly disallow references.
>   5510e1c483 gnu: mes: Remove 0.19.
>   81096caf7d gnu: mes: Switch to Guile 3.0.
>   114a9f1f80 gnu: mescc-tools: Update to 1.2.0.
>   0b9da8b5a2 gnu: m2-planet: Update to 1.8.0.
>   8b627a7701 gnu: mes-minimal: Remove unused variable.

> Removing =E2=80=98mes-rb5=E2=80=99 was a bit disheartening but I guess it=
=E2=80=99d have to be
> updated to the current tool versions.

Yeah, a bit sad but OK I guess.

> I removed Mes 0.19 because it failed to build with Guile 3.0 and didn=E2=
=80=99t
> appear to be needed any longer.
>
> Let me know if you think I did anything wrong!

LGTM!

Greetings,
Janneke

--=20
Jan Nieuwenhuizen <janneke@HIDDEN> | GNU LilyPond http://lilypond.org
Freelance IT http://JoyofSource.com | Avatar=C2=AE http://AvatarAcademy.com




Information forwarded to bug-guix@HIDDEN:
bug#49515; Package guix. Full text available.
bug closed, send any further explanations to 49515 <at> debbugs.gnu.org and Ludovic Courtès <ludo@HIDDEN> Request was from Ludovic Courtès <ludo@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 49515 <at> debbugs.gnu.org:


Received: (at 49515) by debbugs.gnu.org; 26 Jul 2021 11:40:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jul 26 07:40:48 2021
Received: from localhost ([127.0.0.1]:50080 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1m7yyW-0006uV-Fq
	for submit <at> debbugs.gnu.org; Mon, 26 Jul 2021 07:40:48 -0400
Received: from eggs.gnu.org ([209.51.188.92]:60880)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1m7yyU-0006uD-DB
 for 49515 <at> debbugs.gnu.org; Mon, 26 Jul 2021 07:40:46 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:37600)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1m7yyO-0006vQ-0A; Mon, 26 Jul 2021 07:40:40 -0400
Received: from [2001:660:6102:320:e120:2c8f:8909:cdfe] (port=42920 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <ludo@HIDDEN>)
 id 1m7yyN-0007CQ-7E; Mon, 26 Jul 2021 07:40:39 -0400
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Jan Nieuwenhuizen <janneke@HIDDEN>
Subject: Re: bug#49515: [core-updates] mescc-tools tests fail
References: <87k0lxafl6.fsf@HIDDEN> <87o8az49ly.fsf@HIDDEN>
 <87im16j4bo.fsf@HIDDEN>
Date: Mon, 26 Jul 2021 13:40:37 +0200
In-Reply-To: <87im16j4bo.fsf@HIDDEN> (Jan Nieuwenhuizen's message of "Mon, 19
 Jul 2021 06:49:31 +0200")
Message-ID: <87fsw18fre.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 49515
Cc: 49515 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi Janneke!

Jan Nieuwenhuizen <janneke@HIDDEN> skribis:

>> Ludovic Court=C3=A8s <ludo@HIDDEN> skribis:
>>
>>> On commit 9b4c3c675c05870e5983c21ce4ff944e0b0bc2fa of =E2=80=98core-upd=
ates=E2=80=99,
>>> mescc-tools fails tests, with generated binaries segfaulting:
>>>
>>> $ ./pre-inst-env guix build mescc-tools
>>>
>>> [=E2=80=A6]
>>>
>>> + . ./sha256.sh
>>> ++ set -ex
>>> ++ ./bin/get_machine
>>> + ./bin/M1 -f test/test3/defs -f test/test3/lisp.s --BigEndian --archit=
ecture knight-native -o test/test3/hold
>>> + '[' amd64 =3D amd64 ']'
>>> + ./test/results/test1-binary
>>> + ./bin/hex2 -f elf_headers/elf32.hex2 -f test/test2/hold --LittleEndia=
n --architecture x86 --BaseAddress 0x8048000 -o test/results/test2-binary -=
-exec_enable
>>> test/test1/hello.sh: line 37:   125 Segmentation fault      ./test/resu=
lts/test1-binary < test/test1/hex0.hex0 > test/test1/proof1

[...]

>> Should we upgrade instead?  If we do, what=E2=80=99s the potential for b=
reakage?
>> Should =E2=80=98mes-rb5=E2=80=99 be kept on an older version?
>
> We could try that, I really can't tell if upgrading to 1.1.0 creates
> a different mes binary.

I took this route and everything went well, and we can now build
=E2=80=98bootstrap-tarballs=E2=80=99 on x86_64-linux.  I ended up doing add=
itional
changes:

  e2690a8eb2 gnu: mes-rb5: Remove.
  da32015db0 gnu: mes-minimal-stripped: Explicitly disallow references.
  5510e1c483 gnu: mes: Remove 0.19.
  81096caf7d gnu: mes: Switch to Guile 3.0.
  114a9f1f80 gnu: mescc-tools: Update to 1.2.0.
  0b9da8b5a2 gnu: m2-planet: Update to 1.8.0.
  8b627a7701 gnu: mes-minimal: Remove unused variable.

Removing =E2=80=98mes-rb5=E2=80=99 was a bit disheartening but I guess it=
=E2=80=99d have to be
updated to the current tool versions.

I removed Mes 0.19 because it failed to build with Guile 3.0 and didn=E2=80=
=99t
appear to be needed any longer.

Let me know if you think I did anything wrong!

Thanks,
Ludo=E2=80=99.




Information forwarded to bug-guix@HIDDEN:
bug#49515; Package guix. Full text available.

Message received at 49515 <at> debbugs.gnu.org:


Received: (at 49515) by debbugs.gnu.org; 19 Jul 2021 04:49:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jul 19 00:49:49 2021
Received: from localhost ([127.0.0.1]:57857 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1m5LDt-00035t-1S
	for submit <at> debbugs.gnu.org; Mon, 19 Jul 2021 00:49:49 -0400
Received: from eggs.gnu.org ([209.51.188.92]:54996)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <janneke@HIDDEN>) id 1m5LDr-00035h-Du
 for 49515 <at> debbugs.gnu.org; Mon, 19 Jul 2021 00:49:43 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:58796)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <janneke@HIDDEN>)
 id 1m5LDl-0003S9-Ez; Mon, 19 Jul 2021 00:49:37 -0400
Received: from [2001:980:1b4f:1:42d2:832d:bb59:862] (port=53372
 helo=dundal.janneke.lilypond.org)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <janneke@HIDDEN>)
 id 1m5LDi-00086X-Cu; Mon, 19 Jul 2021 00:49:37 -0400
From: Jan Nieuwenhuizen <janneke@HIDDEN>
To: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>
Subject: Re: bug#49515: [core-updates] mescc-tools tests fail
Organization: AvatarAcademy.nl
References: <87k0lxafl6.fsf@HIDDEN> <87o8az49ly.fsf@HIDDEN>
X-Url: http://AvatarAcademy.nl
Date: Mon, 19 Jul 2021 06:49:31 +0200
In-Reply-To: <87o8az49ly.fsf@HIDDEN> ("Ludovic =?utf-8?Q?Court=C3=A8s=22'?=
 =?utf-8?Q?s?= message of "Sun, 18 Jul 2021 23:04:25 +0200")
Message-ID: <87im16j4bo.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 49515
Cc: 49515 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Ludovic Court=C3=A8s writes:

Hello,

> Ludovic Court=C3=A8s <ludo@HIDDEN> skribis:
>
>> On commit 9b4c3c675c05870e5983c21ce4ff944e0b0bc2fa of =E2=80=98core-upda=
tes=E2=80=99,
>> mescc-tools fails tests, with generated binaries segfaulting:
>>
>> $ ./pre-inst-env guix build mescc-tools
>>
>> [=E2=80=A6]
>>
>> + . ./sha256.sh
>> ++ set -ex
>> ++ ./bin/get_machine
>> + ./bin/M1 -f test/test3/defs -f test/test3/lisp.s --BigEndian --archite=
cture knight-native -o test/test3/hold
>> + '[' amd64 =3D amd64 ']'
>> + ./test/results/test1-binary
>> + ./bin/hex2 -f elf_headers/elf32.hex2 -f test/test2/hold --LittleEndian=
 --architecture x86 --BaseAddress 0x8048000 -o test/results/test2-binary --=
exec_enable
>> test/test1/hello.sh: line 37:   125 Segmentation fault      ./test/resul=
ts/test1-binary < test/test1/hex0.hex0 > test/test1/proof1
>
> [...]

How weird!  I wonder what changed...

>> builder for `/gnu/store/lir8pmc63k1bcj4ml9gsx1769aw9ndj2-mescc-tools-0.7=
.0.drv' failed with exit code 1
>
> I found that this upstream commit, which made it in version 1.1.0, fixes
> the segfault:
>
>   commit e633669dfdf16f503a7d740b9058e343536533b4
>   Author: nimaje <nimaje@HIDDEN_channel>
>   Date:   Thu Oct 15 19:12:18 2020 -0400
>
>       Fix ELF headers to be more well behaved

[..]

> Should we upgrade instead?  If we do, what=E2=80=99s the potential for br=
eakage?
> Should =E2=80=98mes-rb5=E2=80=99 be kept on an older version?

We could try that, I really can't tell if upgrading to 1.1.0 creates
a different mes binary.

Greetings,
Janneke

--=20
Jan Nieuwenhuizen <janneke@HIDDEN> | GNU LilyPond http://lilypond.org
Freelance IT http://JoyofSource.com | Avatar=C2=AE http://AvatarAcademy.com




Information forwarded to bug-guix@HIDDEN:
bug#49515; Package guix. Full text available.

Message received at 49515 <at> debbugs.gnu.org:


Received: (at 49515) by debbugs.gnu.org; 18 Jul 2021 21:08:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jul 18 17:08:17 2021
Received: from localhost ([127.0.0.1]:57507 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1m5E1I-0000fE-PA
	for submit <at> debbugs.gnu.org; Sun, 18 Jul 2021 17:08:17 -0400
Received: from eggs.gnu.org ([209.51.188.92]:39694)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1m5E1H-0000f3-Fc
 for 49515 <at> debbugs.gnu.org; Sun, 18 Jul 2021 17:08:15 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:51698)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1m5E1B-0006Se-K3; Sun, 18 Jul 2021 17:08:09 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=45216 helo=ribbon)
 by fencepost.gnu.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1m5E1B-0004g1-CC; Sun, 18 Jul 2021 17:08:09 -0400
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: 49515 <at> debbugs.gnu.org
Subject: Re: bug#49515: [core-updates] mescc-tools tests fail
References: <87k0lxafl6.fsf@HIDDEN> <87o8az49ly.fsf@HIDDEN>
Date: Sun, 18 Jul 2021 23:08:08 +0200
In-Reply-To: <87o8az49ly.fsf@HIDDEN> ("Ludovic =?utf-8?Q?Court=C3=A8s=22'?=
 =?utf-8?Q?s?= message of "Sun, 18 Jul 2021 23:04:25 +0200")
Message-ID: <87im1749fr.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 49515
Cc: Jan Nieuwenhuizen <janneke@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Ludovic Court=C3=A8s <ludo@HIDDEN> skribis:

> I tried backporting it (patch below) but that leads to:

And here=E2=80=99s the patch.


--=-=-=
Content-Type: text/x-patch
Content-Disposition: inline; filename=mescc-tools-segfault.patch
Content-Description: the patch

commit e633669dfdf16f503a7d740b9058e343536533b4
Author: nimaje <nimaje@HIDDEN_channel>
Date:   Thu Oct 15 19:12:18 2020 -0400

    Fix ELF headers to be more well behaved

diff --git a/elf_headers/elf32-debug.hex2 b/elf_headers/elf32-debug.hex2
index 667b032..9fe0183 100644
--- a/elf_headers/elf32-debug.hex2
+++ b/elf_headers/elf32-debug.hex2
@@ -33,7 +33,7 @@
 01                             # e_ident[EI_DATA] Indicating little endianness
 01                             # e_ident[EI_VERSION] Indicating original elf
 
-00                             # e_ident[EI_OSABI] Set at 0 because none cares
+03                             # e_ident[EI_OSABI] Set at 3 because FreeBSD is strict
 00                             # e_ident[EI_ABIVERSION] See above
 
 00 00 00 00 00 00 00           # e_ident[EI_PAD]
diff --git a/elf_headers/elf32.hex2 b/elf_headers/elf32.hex2
index 45d365c..6432523 100644
--- a/elf_headers/elf32.hex2
+++ b/elf_headers/elf32.hex2
@@ -34,7 +34,7 @@
 01                             # e_ident[EI_DATA] Indicating little endianness
 01                             # e_ident[EI_VERSION] Indicating original elf
 
-00                             # e_ident[EI_OSABI] Set at 0 because none cares
+03                             # e_ident[EI_OSABI] Set at 3 because FreeBSD is strict
 00                             # e_ident[EI_ABIVERSION] See above
 
 00 00 00 00 00 00 00           # e_ident[EI_PAD]
diff --git a/elf_headers/elf64.hex2 b/elf_headers/elf64.hex2
index 23d2a4a..6c10442 100644
--- a/elf_headers/elf64.hex2
+++ b/elf_headers/elf64.hex2
@@ -27,7 +27,7 @@
 01                 ## e_ident[EI_DATA] Indicating little endianness
 01                 ## e_ident[EI_VERSION] Indicating original elf
 
-00                 ## e_ident[EI_OSABI] Set at 0 because none cares
+03                 ## e_ident[EI_OSABI] Set at 3 because FreeBSD is strict
 00                 ## e_ident[EI_ABIVERSION] See above
 
 00 00 00 00 00 00 00 ## e_ident[EI_PAD]
@@ -53,7 +53,7 @@
 ## Program Header
 :ELF_program_headers
 01 00 00 00             ## p_type
-06 00 00 00             ## Flags
+07 00 00 00             ## ph_flags: PF-X|PF-W|PF-R = 7
 00 00 00 00 00 00 00 00 ## p_offset
 
 &ELF_base 00 00 00 00 ## p_vaddr
diff --git a/test/test.answers b/test/test.answers
index d449db4..9b366f7 100644
--- a/test/test.answers
+++ b/test/test.answers
@@ -1,12 +1,12 @@
-b5a1dbfb4b9e42f839cd41f704b2d20d67705be5f5214d194d08026006e823a2  test/results/test0-binary
-34cd00306059776d0a1c54dff9d1a4ecb9915fa5b92746b6999c67e535f56b7c  test/results/test1-binary
-2505fa977f1eb9b8eb9cc338af6f606fb8341f1e2f341f71b249c50e7af5e0a7  test/results/test10-binary
-e27aa179b47bd21b8a43f460ef11622dcd13767cb515000ae583dc2706b89657  test/results/test11-binary
-1757e43a482f632286933a56d5da1e87d6385366adfa830df363ba6060a12784  test/results/test2-binary
+054359eb2b4e4f75aa212a41f90654b18b1efdde7ba08aac12bd9c21b1a12cf6  test/results/test0-binary
+56c3021ae5d31e1f57552f103e309603636de5ff38948f1be3e810d9ea0e670b  test/results/test1-binary
+2027e0c8d6295f041d338a430c5a3d3aae042294e5ba4ad1eb08bed16b147671  test/results/test10-binary
+ce9e76b600fdf67589e9180571bed092e9e091a3bf70dc852facd1b678d9df7b  test/results/test11-binary
+7247e7537ef3a83d4c557941bf59a591d6db0688c7a12362af7d14adac238ad4  test/results/test2-binary
 2b80849180d5fb3757bcca2471b6337808e5b5ca80b18d93fa82ddef0435b84b  test/results/test3-binary
-7db345c74d6ee13f21857f9f9419db2bb0890782923485b05dd9eb29b6436efa  test/results/test4-binary
-a7b5c22218bdad3cb8f74a7951fa1425fee5adafdf206420fd020d92b4a13b5e  test/results/test5-binary
-7123c8033949312d9325bffe02246bf599463f214eb0b281e7187c7b06818bae  test/results/test6-binary
-5992d312f114019d955195d50af25f68c3ab079b1e115ddf31f1aca2431d5dca  test/results/test7-binary
+310bea3129335b2cbda70fd591b2cf079b6f7fc19b22f12061a5379ba96dbdae  test/results/test4-binary
+1b09d2b8a3848d691d5d5927f80b6acaad57174b7653d88fe07cd1f6f4bd6f3d  test/results/test5-binary
+61d70db94077ee71b5522f44344baf3943c02559fb1c3e311cfe2fb6cb652d55  test/results/test6-binary
+5cba7bcb9de863c721613b5fafa17277e9e83336e32c8e7e59ee76d003ed5f29  test/results/test7-binary
 a71dc25bcba2a7298b9b9024a7927e215c5081a9ff90a6afa9b583be6c0a7e06  test/results/test8-binary
-b3ec35dc3ce5335ad384b8b2b8b7930aa414014e2bafa61bb6a2b7be8674b88f  test/results/test9-binary
+7fb2aa7451ea132a98f3900b140c8eb3d50751aa6adeac23fd2d766fce2635d4  test/results/test9-binary
diff --git a/test/test1/hex0.hex0 b/test/test1/hex0.hex0
index 7060a6d..611a86f 100644
--- a/test/test1/hex0.hex0
+++ b/test/test1/hex0.hex0
@@ -52,7 +52,7 @@ FB 00 60 00 00 00 00 00 ## e_entry Address of the entry point
 
 ## Program Header table
 01 00 00 00             ## p_type
-06 00 00 00             ## Flags
+07 00 00 00             ## ph_flags: PF-X|PF-W|PF-R = 7
 00 00 00 00 00 00 00 00 ## p_offset
 00 00 60 00 00 00 00 00 ## p_vaddr
 00 00 00 00 00 00 00 00 ## Undefined
diff --git a/test/test1/hex1.hex0 b/test/test1/hex1.hex0
index a0aa3bc..1c6e0bf 100644
--- a/test/test1/hex1.hex0
+++ b/test/test1/hex1.hex0
@@ -38,7 +38,7 @@
 
 ## Program Header table
 01 00 00 00                     # p_type
-06 00 00 00                     # Flags
+07 00 00 00                     # ph_flags: PF-X|PF-W|PF-R = 7
 00 00 00 00 00 00 00 00         # p_offset
 00 00 60 00 00 00 00 00         # p_vaddr
 00 00 00 00 00 00 00 00         # Undefined
diff --git a/test/test1/proof1.answer b/test/test1/proof1.answer
index 7d3bb85..8c441ba 100644
--- a/test/test1/proof1.answer
+++ b/test/test1/proof1.answer
@@ -1 +1 @@
-4379770c34e718157f856d938f870ad8179b268e5454f9ff272aad4e43265149  test/test1/proof1
+d1172d0456de0ae4d05705fc7d81c424f4a277b7725d449829322ce07224bebf  test/test1/proof1
diff --git a/test/test1/proof2.answer b/test/test1/proof2.answer
index 2440710..6edd102 100644
--- a/test/test1/proof2.answer
+++ b/test/test1/proof2.answer
@@ -1 +1 @@
-5ac7c9c6671709682e06153310c112df5b9352af6f6fef93a3370566d28a9a90  test/test1/proof2
+e6b14d3e5935e52a49beff99b766dcd7c842ae2a8d76f4d4c8b10c2d6d146181  test/test1/proof2
diff --git a/test/test2/hex0.hex0 b/test/test2/hex0.hex0
index 126f909..6697221 100644
--- a/test/test2/hex0.hex0
+++ b/test/test2/hex0.hex0
@@ -42,7 +42,7 @@ FB 00 60 00 00 00 00 00 ## e_entry Address of the entry point
 
 ## Program Header table
 01 00 00 00             ## p_type
-06 00 00 00             ## Flags
+07 00 00 00             ## ph_flags: PF-X|PF-W|PF-R = 7
 00 00 00 00 00 00 00 00 ## p_offset
 00 00 60 00 00 00 00 00 ## p_vaddr
 00 00 00 00 00 00 00 00 ## Undefined

--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#49515; Package guix. Full text available.

Message received at 49515 <at> debbugs.gnu.org:


Received: (at 49515) by debbugs.gnu.org; 18 Jul 2021 21:04:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jul 18 17:04:36 2021
Received: from localhost ([127.0.0.1]:57499 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1m5Dxj-0000ZU-W3
	for submit <at> debbugs.gnu.org; Sun, 18 Jul 2021 17:04:36 -0400
Received: from eggs.gnu.org ([209.51.188.92]:39340)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1m5Dxi-0000ZI-MI
 for 49515 <at> debbugs.gnu.org; Sun, 18 Jul 2021 17:04:35 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:51638)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1m5Dxd-00046f-3z; Sun, 18 Jul 2021 17:04:29 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=45214 helo=ribbon)
 by fencepost.gnu.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1m5Dxb-00078S-BO; Sun, 18 Jul 2021 17:04:27 -0400
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: 49515 <at> debbugs.gnu.org
Subject: Re: bug#49515: [core-updates] mescc-tools tests fail
References: <87k0lxafl6.fsf@HIDDEN>
Date: Sun, 18 Jul 2021 23:04:25 +0200
In-Reply-To: <87k0lxafl6.fsf@HIDDEN> ("Ludovic =?utf-8?Q?Court=C3=A8s=22?=
 =?utf-8?Q?'s?= message of "Sun, 11 Jul 2021 01:56:05 +0200")
Message-ID: <87o8az49ly.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 49515
Cc: Jan Nieuwenhuizen <janneke@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi,

Ludovic Court=C3=A8s <ludo@HIDDEN> skribis:

> On commit 9b4c3c675c05870e5983c21ce4ff944e0b0bc2fa of =E2=80=98core-updat=
es=E2=80=99,
> mescc-tools fails tests, with generated binaries segfaulting:
>
> $ ./pre-inst-env guix build mescc-tools
>
> [=E2=80=A6]
>
> + . ./sha256.sh
> ++ set -ex
> ++ ./bin/get_machine
> + ./bin/M1 -f test/test3/defs -f test/test3/lisp.s --BigEndian --architec=
ture knight-native -o test/test3/hold
> + '[' amd64 =3D amd64 ']'
> + ./test/results/test1-binary
> + ./bin/hex2 -f elf_headers/elf32.hex2 -f test/test2/hold --LittleEndian =
--architecture x86 --BaseAddress 0x8048000 -o test/results/test2-binary --e=
xec_enable
> test/test1/hello.sh: line 37:   125 Segmentation fault      ./test/result=
s/test1-binary < test/test1/hex0.hex0 > test/test1/proof1

[...]

> builder for `/gnu/store/lir8pmc63k1bcj4ml9gsx1769aw9ndj2-mescc-tools-0.7.=
0.drv' failed with exit code 1

I found that this upstream commit, which made it in version 1.1.0, fixes
the segfault:

  commit e633669dfdf16f503a7d740b9058e343536533b4
  Author: nimaje <nimaje@HIDDEN_channel>
  Date:   Thu Oct 15 19:12:18 2020 -0400

      Fix ELF headers to be more well behaved

I tried backporting it (patch below) but that leads to:

--8<---------------cut here---------------start------------->8---
test/test2/hello.sh
+ ./bin/M1 -f test/test2/hex.M1 --LittleEndian --Architecture 1 -o test/tes=
t2/hold
+ ./bin/hex2 -f elf_headers/elf32.hex2 -f test/test2/hold --LittleEndian --=
Architecture 1 --BaseAddress 0x8048000 -o test/results/test2-binary --exec_=
enable
++ ./bin/get_machine
+ '[' x86_64 =3D x86_64 ']'
+ ./test/results/test2-binary
+ r=3D0
+ '[' 0 =3D 0 ']'
++ sha256sum -c test/test2/proof.answer
sha256sum: WARNING: 1 computed checksum did NOT match
+ out=3D'test/test2/proof: FAILED'
+ '[' 'test/test2/proof: FAILED' =3D 'test/test2/proof: OK' ']'
+ exit 2
make: *** [makefile:94: test2-binary] Error 2

Test suite failed, dumping logs.
error: in phase 'check': uncaught exception:
%exception #<&invoke-error program: "make" arguments: ("test" "-j" "1" "PRE=
FIX=3D/gnu/store/mklrxb6k2a7f1nspm5az1w3pjgfqyx07-mescc-tools-0.5.2-0.bb062=
b0") exit-status: 2 term-signal: #f stop-signal: #f>=20
phase `check' failed after 0.0 seconds
command "make" "test" "-j" "1" "PREFIX=3D/gnu/store/mklrxb6k2a7f1nspm5az1w3=
pjgfqyx07-mescc-tools-0.5.2-0.bb062b0" failed with status 2
builder for `/gnu/store/5pkxsjjhlirznxfblsm8g4x0dq8nlz6g-mescc-tools-0.5.2-=
0.bb062b0.drv' failed with exit code 1
build of /gnu/store/5pkxsjjhlirznxfblsm8g4x0dq8nlz6g-mescc-tools-0.5.2-0.bb=
062b0.drv failed
--8<---------------cut here---------------end--------------->8---

Should we upgrade instead?  If we do, what=E2=80=99s the potential for brea=
kage?
Should =E2=80=98mes-rb5=E2=80=99 be kept on an older version?

WDYT, Janneke?  :-)

Thanks,
Ludo=E2=80=99.




Information forwarded to bug-guix@HIDDEN:
bug#49515; Package guix. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 10 Jul 2021 23:56:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jul 10 19:56:09 2021
Received: from localhost ([127.0.0.1]:33637 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1m2MpN-0003pQ-4W
	for submit <at> debbugs.gnu.org; Sat, 10 Jul 2021 19:56:09 -0400
Received: from lists.gnu.org ([209.51.188.17]:33978)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1m2MpM-0003pJ-0g
 for submit <at> debbugs.gnu.org; Sat, 10 Jul 2021 19:56:08 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:42708)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <ludo@HIDDEN>) id 1m2MpL-0000O4-ND
 for bug-guix@HIDDEN; Sat, 10 Jul 2021 19:56:07 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:51196)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>) id 1m2MpL-0000FM-G2
 for bug-guix@HIDDEN; Sat, 10 Jul 2021 19:56:07 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=42928 helo=ribbon)
 by fencepost.gnu.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>) id 1m2MpL-00030Q-7n
 for bug-guix@HIDDEN; Sat, 10 Jul 2021 19:56:07 -0400
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: bug-guix@HIDDEN
Subject: [core-updates] mescc-tools tests fail
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 23 Messidor an 229 de la =?utf-8?Q?R=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Sun, 11 Jul 2021 01:56:05 +0200
Message-ID: <87k0lxafl6.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

On commit 9b4c3c675c05870e5983c21ce4ff944e0b0bc2fa of =E2=80=98core-updates=
=E2=80=99,
mescc-tools fails tests, with generated binaries segfaulting:

--8<---------------cut here---------------start------------->8---
$ ./pre-inst-env guix build mescc-tools

[=E2=80=A6]

+ . ./sha256.sh
++ set -ex
++ ./bin/get_machine
+ ./bin/M1 -f test/test3/defs -f test/test3/lisp.s --BigEndian --architectu=
re knight-native -o test/test3/hold
+ '[' amd64 =3D amd64 ']'
+ ./test/results/test1-binary
+ ./bin/hex2 -f elf_headers/elf32.hex2 -f test/test2/hold --LittleEndian --=
architecture x86 --BaseAddress 0x8048000 -o test/results/test2-binary --exe=
c_enable
test/test1/hello.sh: line 37:   125 Segmentation fault      ./test/results/=
test1-binary < test/test1/hex0.hex0 > test/test1/proof1
++ ./bin/get_machine
make: *** [makefile:104: test1-binary] Error 139
make: *** Waiting for unfinished jobs....
+ '[' amd64 =3D x86 ']'
+ exit 0
+ . ./sha256.sh
++ set -ex
++ ./bin/get_machine
+ '[' amd64 =3D x86 ']'
+ exit 0
+ ./bin/hex2 -f test/test3/hold --BigEndian --architecture knight-native --=
BaseAddress 0 -o test/results/test3-binary
+ . ./sha256.sh
++ set -ex
test/test3/hello.sh: line 23: GET_MACHINE_FLAGS: unbound variable
+ '[' '' =3D 'knight*' ']'
+ exit 0

Test suite failed, dumping logs.
error: in phase 'check': uncaught exception:
%exception #<&invoke-error program: "make" arguments: ("test" "-j" "4" "PRE=
FIX=3D/gnu/store/xps0k41ydjl14lx7cnrgclgsi5cnkib7-mescc-tools-0.7.0" "CC=3D=
gcc") exit-status: 2 term-signal: #f stop-signal: #f>=20
phase `check' failed after 0.1 seconds
command "make" "test" "-j" "4" "PREFIX=3D/gnu/store/xps0k41ydjl14lx7cnrgclg=
si5cnkib7-mescc-tools-0.7.0" "CC=3Dgcc" failed with status 2
builder for `/gnu/store/lir8pmc63k1bcj4ml9gsx1769aw9ndj2-mescc-tools-0.7.0.=
drv' failed with exit code 1
build of /gnu/store/lir8pmc63k1bcj4ml9gsx1769aw9ndj2-mescc-tools-0.7.0.drv =
failed
--8<---------------cut here---------------end--------------->8---

This is a dependency of the =E2=80=98bootstrap-tarballs=E2=80=99 package.

Ludo=E2=80=99.




Acknowledgement sent to Ludovic Courtès <ludo@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-guix@HIDDEN. Full text available.
Report forwarded to bug-guix@HIDDEN:
bug#49515; Package guix. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Tue, 27 Jul 2021 09:45:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.